/*****************************************************************************
*                                                                            *
* void      Edge_Mask()                                                      *
*                                                                            *
******************************************************************************
*                                                                            *
* Kantendetektion mit beliebiger 3x3-Maske                                   *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 23.10.1992                                               *
* Letzte Aenderung: 21.12.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Skalier_Histo(), Make_Icon(), Show_Pic()                       *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"

#define SKALIERUNG 2.0


void Edge_Mask()
{
  long  z, s, Z_Temp, S_Temp;     /* Variablen fuer Zeilen und Spaltenindex */
  long  Index1, Index2, Index;    /* Adresse der beiden Bilder              */
  long  zwerg;
  long  Zmax, Smax;
  int   BildNr1, BildNr2;
  int   i, j;
  int   Maske[3][3];              /* 3x3-Maske mit beliebiger Gewichtung    */

  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Anwendung eines 3x3-Operators *");

  gotoxy(35,20);
  BildNr1=Read_Int("Quell-Bild      ", 1, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used)   return;

  gotoxy(35,21);
  BildNr2=Read_Int("Gradienten-Bild ", 2, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */

  /* Zuerst gewuenschte Maske zeilenweise einlesen                          */
  for (i=0; i<3; i++) {
      WriteText(35,22,"Bitte ");
      gotoxy(41,22);
      WriteInt(i);
      WriteText(42,22,". Zeile des Operators eingeben:");
      for (j=0; j<3; j++) {
          WriteText(35,23,"Element [Zeile][Spalte] [");
          gotoxy(60,23);
          WriteInt(i);
          WriteText(61,23,"][");
          gotoxy(63,23);
          WriteInt(j);
          Maske[i][j]=Read_Int("]", INT_NO_DEFAULT, ':');
          WriteText(65,23,"        ");
      }
  }

  Index1 = (long) (BildNr1) * PIC_SIZE; /* Adresse der beiden Bilder        */
  Index2 = (long) (BildNr2) * PIC_SIZE;

  Zmax = Bild[BildNr1].Zeilen;
  Smax = Bild[BildNr1].Spalten;

  /*------------------------ Faltung durchfuehren --------------------------*/
  for (z=0; z<Zmax; z++) {
      for (s=0; s<Smax; s++) {
          /*---- erste Zeile ----*/
          Z_Temp = (z>0) ? (z-1) : 0;
          Index=Index1+Z_Temp*Smax;
          S_Temp = (s>0) ? (s-1) : 0;
          zwerg  = (int)Maske[0][0] * (int)Pictures[Index+S_Temp];
          zwerg += (int)Maske[0][1] * (int)Pictures[Index+s];
          S_Temp = (s<(Smax-1)) ? (s+1) : (Smax-1);
          zwerg += (int)Maske[0][2] * (int)Pictures[Index+S_Temp];

          /*---- zweite Zeile ----*/
          Index=Index1+z*Smax;
          S_Temp = (s>0) ? (s-1) : 0;
          zwerg += (int)Maske[1][0] * (int)Pictures[Index+S_Temp];
          zwerg += (int)Maske[1][1] * (int)Pictures[Index+s];
          S_Temp = (s<(Smax-1)) ? (s+1) : (Smax-1);
          zwerg += (int)Maske[1][2] * (int)Pictures[Index+S_Temp];

          /*---- dritte Zeile ----*/
          Z_Temp = (z<(Zmax-1)) ? (z+1) : (Zmax-1);
          Index=Index1+Z_Temp*Smax;
          S_Temp = (s>0) ? (s-1) : 0;
          zwerg += (int)Maske[2][0] * (int)Pictures[Index+S_Temp];
          zwerg += (int)Maske[2][1] * (int)Pictures[Index+s];
          S_Temp = (s<(Smax-1)) ? (s+1) : (Smax-1);
          zwerg += (int)Maske[2][2] * (int)Pictures[Index+S_Temp];

          /*---- Betrag der Faltungn ----*/
          zwerg = (zwerg<0.0) ? (-zwerg) : zwerg;
          zwerg = (int)((float)zwerg / SKALIERUNG);
          Pictures[Index2++]=(zwerg>WEISS) ? WEISS : zwerg;
      }
  }

  /* Bildinformation zum Schluss korrekt setzen                             */
  Bild[BildNr2].Zeilen =Zmax;
  Bild[BildNr2].Spalten=Smax;
  Bild[BildNr2].Used   =TRUE;
  Bild[BildNr2].Color  =FALSE;

  /*--- Ausgabe des Gradientenbildes mit 255 als Obergrenze (5%) -----------*/
  Skalier_Histo( BildNr2+1, 5);

  Make_Icon(BildNr2);
  Show_Pic(BildNr2, BildNr2+1);
}
