/*****************************************************************************
*                                                                            *
* void      Gamma(int BildNr, float Gamma)                                   *
*                                                                            *
******************************************************************************
*                                                                            *
* Grauwertaenderung mittels Gamma-Korrektur                                  *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 16.03.1993                                               *
* Letzte Aenderung: 16.03.1993                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input:  BildNr = Nummer des Ausgangs-/Zielbildes (1<=BildNr<=MAX_PICTURE)  *
*         Gamma 0-5: Faktor Gamma                                            *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(), Read_Float(),      *
*             Make_Icon(), Show_Pic()                                        *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Gamma(int BildNr, float Gamma)
{
  unsigned char Grauwert[MAX_COLOR];              /* Transformations-LUT    */
  long s;                                         /* Zeilen-/Spaltenzaehler */
  long Index;                                     /* Bild-Anfangsadresse    */
  int i;

  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Gamma-Korrektur *");

  if (BildNr == FALSE) {
     gotoxy(35,20);
     BildNr=Read_Int("Bild Nr. ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben? Ist dieses Bild ueberhaupt benutzt?   */
  if ((BildNr<=0) || (BildNr>MAX_PICTURE)) return;
  BildNr--;                           /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr].Used) return;

  Index = (long) (BildNr) * PIC_SIZE;

  while ( (Gamma<1.0) || (Gamma>5.0) ) {
      gotoxy(35,22);
      Gamma=Read_Float("Faktor Gamma (1.0-5.0) ", 2.3, ':');
  }

  /* Neue "Look-Up-Tabelle" erstellen ...                                   */
  for (i=0; i<MAX_COLOR; i++)
      Grauwert[i]=(int)(pow((float)i/(float)WEISS, 1.0/Gamma) * WEISS + 0.5);

  /* ... und das ganze Bild aufgrund dieser LUT transformieren.             */
  for (s=0; s<PIC_SIZE; s++)
       Pictures[Index] = Grauwert[ Pictures[Index++] ];

  Make_Icon(BildNr);
  Show_Pic(BildNr, BildNr+1);

}
