/*****************************************************************************
*                                                                            *
* void      Median(BildNr1, BildNr2, Form, Groesse)                          *
*                                                                            *
******************************************************************************
*                                                                            *
* Medianfilterung in verschiedenen Groessen und Formen.                      *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 05.11.1992                                               *
* Letzte Aenderung: 05.11.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input: BildNr1   = Quelbild                                                *
*        BildNr2   = Zielbild (gefiltertes Bild)                             *
*        Form      = 1: -                                                    *
*                    2: |                                                    *
*                    3: +                                                    *
*                    4: x                                                    *
*        Groesse   = Groesse des Fensters 3x3, 5x5, 7x7                      *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Geduld(), Median_Wert(), Make_Icon(), Show_Pic()               *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Median(int BildNr1, int BildNr2, int Form, int Groesse)
{
  long  z, s, Z_Temp, S_Temp;     /* Variablen fuer Zeilen und Spaltenindex */
  long  Index1, Index2, Index;    /* Adresse der beiden Bilder              */
  int   i, j, k;
  int   Pixelzahl;
  unsigned char Pixelvektor[50];  /* maximal 7*7=49 Werte zu sortieren      */
  long  Zmax, Smax;


  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Glaettung durch Medianfilter *");

  if (!BildNr1) {
     gotoxy(35,20);
     BildNr1=Read_Int("Quell-Bild            ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used)   return;

  if (!BildNr2) {
     gotoxy(35,21);
     BildNr2=Read_Int("Median-Bild           ", 2, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */

  while ((Groesse!=3) && (Groesse!=5) && (Groesse!=7)) {
     gotoxy(35,22);
     Groesse=Read_Int("Filtergroesse (3,5,7) ", 3, ':');
  }
  if (Form<3)   Pixelzahl=Groesse;
  else          Pixelzahl=Groesse+Groesse-1;
  Groesse=(int)(Groesse/2);

  Index1 = (long) (BildNr1) * PIC_SIZE; /* Adresse der beiden Bilder        */
  Index2 = (long) (BildNr2) * PIC_SIZE;

  Zmax = Bild[BildNr1].Zeilen;
  Smax = Bild[BildNr1].Spalten;

  Geduld();

  for (z=0; z<Zmax; z++) {
      for (s=0; s<Smax; s++) {
          k=0;
          /* Pixel-Werte je nach Form aufsammeln. Besonderheiten am Rand.   */
          for (i= -Groesse; i<=Groesse; i++) {
              Z_Temp=z+i;
              if (Z_Temp<0) Z_Temp= -Z_Temp-1;
              else if (Z_Temp>=Zmax) Z_Temp=z-i+1;
              Z_Temp=Z_Temp*Smax;
              for (j= -Groesse; j<=Groesse; j++) {
                  S_Temp=s+j;
                  if (S_Temp<0) S_Temp= -S_Temp-1;
                  else if (S_Temp>=Smax) S_Temp=s-j+1;
                  Index=Index1+Z_Temp+S_Temp;
                  if ((Form==1) && (i==0))
                     Pixelvektor[k++]=Pictures[Index];
                  else if ((Form==2) && (j==0))
                     Pixelvektor[k++]=Pictures[Index];
                  else if ((Form==3) && ((j==0) || (i==0)))
                     Pixelvektor[k++]=Pictures[Index];
                  else if ((Form==4) && ((j==i) || (j==(-i))))
                     Pixelvektor[k++]=Pictures[Index];
              }
          }
          /* Median der Pixelwerte berechnen und im Zielbild abspeichern    */
          Pictures[Index2++]=Median_Wert(Pixelvektor, Pixelzahl, Pixelzahl/2);
      }
  }

  /* Bildinformation zum Schluss korrekt setzen                             */
  Bild[BildNr2].Zeilen =Zmax;
  Bild[BildNr2].Spalten=Smax;
  Bild[BildNr2].Used   =TRUE;
  Bild[BildNr2].Color  =FALSE;

  Make_Icon(BildNr2);
  Show_Pic(BildNr2, BildNr2+1);
}
