/*****************************************************************************
*                                                                            *
* void      Rotation()                                                       *
*                                                                            *
******************************************************************************
*                                                                            *
* Dreht ein Bild um den Bildmittelpunkt in mathematisch negativer Richtung.  *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 09.10.1992                                               *
* Letzte Aenderung: 12.11.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Make_Icon(), Show_Pic()                                        *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Rotation()
{
  long  z, s, zz, ss;                     /* Laufvariablen Zeilen / Spalten */
  int   S_Res_Pic, Z_ResHalbe, S_ResHalbe;/* Angaben ueber die Aufloesung   */
  float Grad;                             /* Rotationswinkel in Grad        */
  float CosAlpha, SinAlpha, Alpha;/* Rotationswinkel und sin(), cos() davon */
  int   BildNr1, BildNr2;                 /* Nummer von Quell - u. Zielbild */
  long  Index1, Index2;                   /* Adressen der beiden Bilder     */


  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Drehung um den Bildmittelpunkt *");

  gotoxy(35,20);
  BildNr1=Read_Int("Quell-Bild ", 1, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used) return;

  gotoxy(35,21);
  BildNr2=Read_Int("Ziel-Bild  ", 2, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */

  Index1 = (long) (BildNr1) * PIC_SIZE; /* Adresse von Quell- und Zielbild  */
  Index2 = (long) (BildNr2) * PIC_SIZE;

  gotoxy(35,23);
  Grad = Read_Float("Rotationswinkel (Grad) ", FLOAT_NO_DEFAULT, '?' );

  /* Initialisierung: Ziel-Bild loeschen                                    */
  for (s=0; s<PIC_SIZE; s++) Pictures[Index2++]=SCHWARZ;
  Index2 = (long) (BildNr2) * PIC_SIZE;

  /* Rotationsformel:
     x' = x*cos(Alpha) - y*sin(Alpha)
     y' = x*sin(Alpha) + y*cos(Alpha)
     Der Ursprung ist dazu immer in den Bildmittelpunkt zu verschieben      */
  
  /* Initialisierung aller Hilfsvariablen zur Beschleunigung der Berechnung */
  Alpha     = PI*Grad/180.0;
  CosAlpha  = cos(Alpha);
  SinAlpha  = sin(Alpha);

  S_Res_Pic = Bild[BildNr1].Spalten;
  S_ResHalbe = S_Res_Pic/2;
  Z_ResHalbe = Bild[BildNr1].Zeilen/2;

  /* Fuer alle Punkte im Zielbild den entsprechenden Punkt im Ausgangsbild  */
  /* suchen. Dadurch entstehen keine Luecken im Bild.                       */
  for (z=0; z<Z_RES_MAX; z++)
      for (s=0; s<S_RES_MAX; s++) {
          zz = (int) ((float)(z-Z_ResHalbe)*CosAlpha -
                      (float)(s-S_ResHalbe)*SinAlpha + 0.5)
                    + Z_ResHalbe;
          ss = (int) ((float)(z-Z_ResHalbe)*SinAlpha +
                      (float)(s-S_ResHalbe)*CosAlpha + 0.5)
                    + S_ResHalbe;
          /* Ergebnis uebernehmen, falls Punkt wirklich im Quellbild liegt  */
          if ( (0<=zz) && (zz<S_RES_MAX) && (0<=ss) && (ss<Z_RES_MAX) )
             Pictures[Index2+z*S_Res_Pic+s]=Pictures[Index1+zz*S_Res_Pic+ss];
      }

  /* Neue Bildinformation abspeichern.                                      */
  Bild[BildNr2].Zeilen =Z_RES_MAX;  /* Das neue Bild hat zur Sicherheit ... */
  Bild[BildNr2].Spalten=S_RES_MAX;  /* ... Maximalgroesse!                  */
  Bild[BildNr2].Used   =TRUE;
  Bild[BildNr2].Color  =FALSE;

  /* Bild anzeigen                                                          */
  Make_Icon(BildNr2);
  Show_Pic(BildNr2, BildNr2+1);

}
