/*****************************************************************************
*                                                                            *
* void      Test_Bild(int Art)                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Erzeugt ein Testbild 256x256 in Form von Kreis, Rechteck, Streifen.        *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 10.10.1992                                               *
* Letzte Aenderung: 16.03.1993                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Make_Icon(), Show_Pic()                                        *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Test_Bild(int Art)
{
  long z, s;
  long Index;
  int BildNr;
  int x, y, d, i;
  int Laenge, Breite;
  int Radius;
  int Breit_Weiss, Breit_Schw;

  ClearTextWindow(35,18,80,25);
  switch (Art) {
     case 1:
          WriteText(35,18,"* Testbild Kreis erzeugen *");
          break;
     case 2:
          WriteText(35,18,"* Testbild Rechteck erzeugen *");
          break;
     case 3:
          WriteText(35,18,"* Testbild Streifen erzeugen *");
          break;
  }

  gotoxy(35,20);
  BildNr=Read_Int("Bild Nr. ", 1, ':');
  /* Gueltige Bild-Nummer eingegeben? Ist dieses Bild ueberhaupt benutzt?   */
  if ((BildNr<=0) || (BildNr>MAX_PICTURE)) return;
  BildNr--;                           /* die Zaehlung faengt immer bei 0 an */

  Index = (long) (BildNr) * PIC_SIZE; /* Anfangsadresse des Bildes          */
  for (z=0; z<PIC_SIZE; z++)
      Pictures[Index+z]=SCHWARZ;

  switch (Art) {
     case 1:     /* Testbild mit einem Kreis erzeugen                       */
          do {
             gotoxy(35,21);
             Radius=Read_Int("Kreis-Radius (1-128) ", 40, ':');
          } while ((Radius<1) || (Radius>128));

          /* Bresenham fuer Kreise; siehe Foley/v.Dam Seite 86 ff.          */
          for (i=0; i<Radius; i++) {
              x=0;
              y=i;
              d=1-i;
              Pictures[Index+(long)(y+128)*S_RES_MAX+(long)x+128] = WEISS;
              Pictures[Index+(long)(y+128)*S_RES_MAX-(long)x+128] = WEISS;
              Pictures[Index+(long)(128-y)*S_RES_MAX-(long)x+128] = WEISS;
              Pictures[Index+(long)(128-y)*S_RES_MAX+(long)x+128] = WEISS;
              Pictures[Index+(long)(x+128)*S_RES_MAX+(long)y+128] = WEISS;
              Pictures[Index+(long)(x+128)*S_RES_MAX-(long)y+128] = WEISS;
              Pictures[Index+(long)(128-x)*S_RES_MAX-(long)y+128] = WEISS;
              Pictures[Index+(long)(128-x)*S_RES_MAX+(long)y+128] = WEISS;
              while (y>x) {
                 if (d<0) {
                    d += x+x+3;
                    x++;
                 } else {
                    d += 2*(x-y)+5;
                    x++;
                    y--;
                 }
                 Pictures[Index+(long)(y+128)*S_RES_MAX+(long)x+128] = WEISS;
                 Pictures[Index+(long)(y+128)*S_RES_MAX-(long)x+128] = WEISS;
                 Pictures[Index+(long)(128-y)*S_RES_MAX-(long)x+128] = WEISS;
                 Pictures[Index+(long)(128-y)*S_RES_MAX+(long)x+128] = WEISS;
                 Pictures[Index+(long)(x+128)*S_RES_MAX+(long)y+128] = WEISS;
                 Pictures[Index+(long)(x+128)*S_RES_MAX-(long)y+128] = WEISS;
                 Pictures[Index+(long)(128-x)*S_RES_MAX-(long)y+128] = WEISS;
                 Pictures[Index+(long)(128-x)*S_RES_MAX+(long)y+128] = WEISS;
              }
          }
          break;
     case 2:     /* Testbild mit einem achsenparallelen Rechteck erzeugen   */
          do {
             gotoxy(35,21);
             Laenge=Read_Int("Laenge-Rechteck (1-256) ", 128, ':');
          } while ((Laenge<1) || (Laenge>256));
          do {
             gotoxy(35,22);
             Breite=Read_Int("Breite-Rechteck (1-256)  ",  64, ':');
          } while ((Breite<1) || (Breite>256));

          for (z=(127-Laenge/2); z<(128+Laenge/2); z++)
              for (s=(127-Breite/2); s<(128+Breite/2); s++)
                  Pictures[Index + z*S_RES_MAX + s] = WEISS;
          break;
     case 3:     /* Testbild mit einem Streifenmuster erzeugen              */
          do {
             gotoxy(35,21);
             Breit_Weiss=Read_Int("Breite Weiss   (1-128) ", 32, ':');
          } while ((Breit_Weiss<1) || (Breit_Weiss>128));
          do {
             gotoxy(35,22);
             Breit_Schw =Read_Int("Breite Schwarz (1-128) ", 32, ':');
          } while ((Breit_Schw<1) || (Breit_Schw>128));

          s=0;
          while (s<S_RES_MAX) {
              i=0;
              while ( (i<Breit_Weiss) && (s<S_RES_MAX) ) {
                  for (z=0; z<Z_RES_MAX; z++)
                      Pictures[Index + z*S_RES_MAX + s] = WEISS;
                  s++;
                  i++;
             }
             s += Breit_Schw;
          }
          break;
  }

  /* Genaue Bildabmessungen in Struktur speichern                           */
  Bild[BildNr].Zeilen =Z_RES_MAX;
  Bild[BildNr].Spalten=S_RES_MAX;
  Bild[BildNr].Used   =TRUE;
  Bild[BildNr].Color  =FALSE;

  Make_Icon(BildNr);
  Show_Pic(BildNr, BildNr+1);
}
